#include <com/sun/star/lang/XMain.hpp>
#include <com/sun/star/uno/XComponentContext.hpp>
#include <com/sun/star/uno/Sequence.hxx>
#include <com/sun/star/lang/XMultiComponentFactory.hpp>
#include <com/sun/star/uno/RuntimeException.hpp>
#include <com/sun/star/uno/Reference.hxx>
#include <com/sun/star/lang/XSingleComponentFactory.hpp>
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#include <com/sun/star/registry/XRegistryKey.hpp>

#include <cppuhelper/implbase1.hxx>
#include <cppuhelper/factory.hxx>
#include <cppuhelper/implementationentry.hxx>

#include <rtl/string.hxx>

#include <iostream>


using namespace com::sun::star;
using namespace rtl;
using namespace std;

namespace org { namespace stareditor { 
 
namespace comp {

  // Implementation for the org.stareditor.Main service
  class MyCMain: public cppu::WeakImplHelper1 <lang::XMain> 
  {

    public:

      /*
       * Constructor for this main implementation. Just getting the 
       * XComponentContext for futher use.
       */
      explicit MyCMain (uno::Reference <uno::XComponentContext> const & xCtx): __xCtx(xCtx){}
      
      sal_Int32 SAL_CALL run (uno::Sequence <OUString> const &)  throw (uno::RuntimeException) 
      {
        cout << "Hello URE world in C++ ;)" << endl;
        return 0;
      }

      /*
       * Static creation method of the MyCMain class. 
       * This is used by the component registration methods
       */
      static uno::Reference <uno::XInterface> SAL_CALL create(
          uno::Reference <uno::XComponentContext> const & xContext)
      {
         return static_cast <cppu::OWeakObject *>( 
             new comp::MyCMain(xContext) );
      }
      
      /*
       * Method returning the supported service names for this 
       * implementation class.
       */
      static uno::Sequence<OUString> getSupportedServiceNames() 
      {
         uno::Sequence<OUString> names(1);
         names[0] = OUString(
             RTL_CONSTASCII_USTRINGPARAM("org.stareditor.Main"));
         return names;
      }
      
      /*
       * Method returning the name of the implementation. This is used by the
       * registration methods.
       */
      static OUString getImplementationName()
      {
         return OUString( 
             RTL_CONSTASCII_USTRINGPARAM("org.stareditor.comp.MyCMain") );
      }

    private:
      
      /*
       * Private destructor for the main service
       */
      ~MyCMain(){};

      /*
       * Private member to store the Component Context
       */
      uno::Reference <uno::XComponentContext> __xCtx;
  };

}

  // Structure describing the types implemented in this component
  static struct cppu::ImplementationEntry entries [] =
  {
    {
      comp::MyCMain::create, comp::MyCMain::getImplementationName,
      comp::MyCMain::getSupportedServiceNames,
      cppu::createSingleComponentFactory,
      0, 0
    },
    { 0, 0, 0, 0, 0, 0 }
  };

} }


/*
 * Exported methods needed by regcomp tool. Only a copy/paste for the SDK
 */
extern "C" 
{
  void SAL_CALL component_getImplementationEnvironment(
    sal_Char const ** ppEnvTypeName, uno_Environment ** ppEnv )
  {
        *ppEnvTypeName = CPPU_CURRENT_LANGUAGE_BINDING_NAME;
  }

  void * SAL_CALL component_getFactory( 
      char const * implName, void * xMgr, void * registryKey)
  {
    return cppu::component_getFactoryHelper(
        implName, xMgr, registryKey, org::stareditor::entries);
  }

  sal_Bool SAL_CALL component_writeInfo( void * xMgr, void * xRegistry )
  {
    return cppu::component_writeInfoHelper(
        xMgr, xRegistry, org::stareditor::entries);
  }
}
